spec:
  inputs:
    stage:
      default: build
    boot-image:
      default: quay.io/buildah/stable:v1.38
    build-image-cmd:
      default: ./build-image
---
variables:
  GIT_SUBMODULE_STRATEGY: recursive
default:
  before_script:
    - 'buildah login $CI_REGISTRY -u $CI_REGISTRY_USER --password-stdin <<<$CI_REGISTRY_PASSWORD'
build-image:
  stage: $[[ inputs.stage ]]
  rules:
    - if: '$CI_COMMIT_BRANCH =~ /^ci\// && $CI_COMMIT_BRANCH =~ /\/build-image$/'
  image: $[[ inputs.boot-image ]]
  script:
    - 'EXTRA_PATH=${CI_COMMIT_BRANCH#ci}'
    - 'EXTRA_PATH=${EXTRA_PATH%/build-image}'
    - 'ISO_DAY=$(date +%g%V%u)'
    - 'IMAGE=$CI_REGISTRY_IMAGE$EXTRA_PATH:${ISO_DAY}-${CI_COMMIT_SHA:0:3}'
    - $[[ inputs.build-image-cmd ]] $IMAGE
    - buildah push $IMAGE
    - LATEST=$CI_REGISTRY_IMAGE$EXTRA_PATH:latest
    - buildah tag $IMAGE $LATEST
    - buildah push $LATEST
